## GSimpleAsyncResult

GSimpleAsyncResult — Simple asynchronous results implementation

## Functions

void | (*GSimpleAsyncThreadFunc) ()
GSimpleAsyncResult * | g_simple_async_result_new ()
GSimpleAsyncResult * | g_simple_async_result_new_error ()
GSimpleAsyncResult * | g_simple_async_result_new_from_error ()
GSimpleAsyncResult * | g_simple_async_result_new_take_error ()
void | g_simple_async_result_set_check_cancellable ()
void | g_simple_async_result_set_op_res_gpointer ()
gpointer | g_simple_async_result_get_op_res_gpointer ()
void | g_simple_async_result_set_op_res_gssize ()
gssize | g_simple_async_result_get_op_res_gssize ()
void | g_simple_async_result_set_op_res_gboolean ()
gboolean | g_simple_async_result_get_op_res_gboolean ()
gpointer | g_simple_async_result_get_source_tag ()
gboolean | g_simple_async_result_is_valid ()
void | g_simple_async_result_set_handle_cancellation ()
void | g_simple_async_result_complete ()
void | g_simple_async_result_complete_in_idle ()
void | g_simple_async_result_run_in_thread ()
void | g_simple_async_result_set_from_error ()
void | g_simple_async_result_take_error ()
gboolean | g_simple_async_result_propagate_error ()
void | g_simple_async_result_set_error ()
void | g_simple_async_result_set_error_va ()
void | g_simple_async_report_error_in_idle ()
void | g_simple_async_report_gerror_in_idle ()
void | g_simple_async_report_take_gerror_in_idle ()

## Types and Values

| GSimpleAsyncResult

## Object Hierarchy

        GObject
        ╰── GSimpleAsyncResult

## Implemented Interfaces

GSimpleAsyncResult implements GAsyncResult.

## Includes

    #include <gio/gio.h>

## Description

As of GLib 2.46, GSimpleAsyncResult is deprecated in favor of GTask, which provides a simpler API.

GSimpleAsyncResult implements GAsyncResult.

GSimpleAsyncResult handles GAsyncReadyCallbacks, error reporting, operation cancellation and the final state of an operation, completely transparent to the application. Results can be returned as a pointer e.g. for functions that return data that is collected asynchronously, a boolean value for checking the success or failure of an operation, or a gssize for operations which return the number of bytes modified by the operation; all of the simple return cases are covered.

Most of the time, an application will not need to know of the details of this API; it is handled transparently, and any necessary operations are handled by GAsyncResult's interface. However, if implementing a new GIO module, for writing language bindings, or for complex applications that need better control of how asynchronous operations are completed, it is important to understand this functionality.

GSimpleAsyncResults are tagged with the calling function to ensure that asynchronous functions and their finishing functions are used together correctly.

To create a new GSimpleAsyncResult, call `g_simple_async_result_new()`. If the result needs to be created for a GError, use `g_simple_async_result_new_from_error()` or `g_simple_async_result_new_take_error()`. If a GError is not available (e.g. the asynchronous operation's doesn't take a GError argument), but the result still needs to be created for an error condition, use `g_simple_async_result_new_error()` (or `g_simple_async_result_set_error_va()` if your application or binding requires passing a variable argument list directly), and the error can then be propagated through the use of `g_simple_async_result_propagate_error()`.

An asynchronous operation can be made to ignore a cancellation event by calling `g_simple_async_result_set_handle_cancellation()` with a GSimpleAsyncResult for the operation and `FALSE`. This is useful for operations that are dangerous to cancel, such as close (which would cause a leak if cancelled before being run).

GSimpleAsyncResult can integrate into GLib's event loop, GMainLoop, or it can use GThreads. `g_simple_async_result_complete()` will finish an I/O task directly from the point where it is called. `g_simple_async_result_complete_in_idle()` will finish it from an idle handler in the thread-default main context . `g_simple_async_result_run_in_thread()` will run the job in a separate thread and then deliver the result to the thread-default main context.

To set the results of an asynchronous function, `g_simple_async_result_set_op_res_gpointer()`, `g_simple_async_result_set_op_res_gboolean()`, and `g_simple_async_result_set_op_res_gssize()` are provided, setting the operation's result to a gpointer, gboolean, or gssize, respectively.

Likewise, to get the result of an asynchronous function, `g_simple_async_result_get_op_res_gpointer()`, `g_simple_async_result_get_op_res_gboolean()`, and `g_simple_async_result_get_op_res_gssize()` are provided, getting the operation's result as a gpointer, gboolean, and gssize, respectively.

For the details of the requirements implementations must respect, see GAsyncResult. A typical implementation of an asynchronous operation using GSimpleAsyncResult looks something like this:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92

    static void
    baked_cb (Cake    *cake,
              gpointer user_data)
    {
      // In this example, this callback is not given a reference to the cake,
      // so the GSimpleAsyncResult has to take a reference to it.
      GSimpleAsyncResult *result = user_data;

      if (cake == NULL)
        g_simple_async_result_set_error (result,
                                         BAKER_ERRORS,
                                         BAKER_ERROR_NO_FLOUR,
                                         "Go to the supermarket");
      else
        g_simple_async_result_set_op_res_gpointer (result,
                                                   g_object_ref (cake),
                                                   g_object_unref);

      // In this example, we assume that baked_cb is called as a callback from
      // the mainloop, so it's safe to complete the operation synchronously here.
      // If, however, _baker_prepare_cake () might call its callback without
      // first returning to the mainloop — inadvisable, but some APIs do so —
      // we would need to use g_simple_async_result_complete_in_idle().
      g_simple_async_result_complete (result);
      g_object_unref (result);
    }

    void
    baker_bake_cake_async (Baker              *self,
                           guint               radius,
                           GAsyncReadyCallback callback,
                           gpointer            user_data)
    {
      GSimpleAsyncResult *simple;
      Cake               *cake;

      if (radius < 3)
        {
          g_simple_async_report_error_in_idle (G_OBJECT (self),
                                               callback,
                                               user_data,
                                               BAKER_ERRORS,
                                               BAKER_ERROR_TOO_SMALL,
                                               "%ucm radius cakes are silly",
                                               radius);
          return;
        }

      simple = g_simple_async_result_new (G_OBJECT (self),
                                          callback,
                                          user_data,
                                          baker_bake_cake_async);
      cake = _baker_get_cached_cake (self, radius);

      if (cake != NULL)
        {
          g_simple_async_result_set_op_res_gpointer (simple,
                                                     g_object_ref (cake),
                                                     g_object_unref);
          g_simple_async_result_complete_in_idle (simple);
          g_object_unref (simple);
          // Drop the reference returned by _baker_get_cached_cake();
          // the GSimpleAsyncResult has taken its own reference.
          g_object_unref (cake);
          return;
        }

      _baker_prepare_cake (self, radius, baked_cb, simple);
    }

    Cake *
    baker_bake_cake_finish (Baker        *self,
                            GAsyncResult *result,
                            GError      **error)
    {
      GSimpleAsyncResult *simple;
      Cake               *cake;

      g_return_val_if_fail (g_simple_async_result_is_valid (result,
                                                            G_OBJECT (self),
                                                            baker_bake_cake_async),
                            NULL);

      simple = (GSimpleAsyncResult *) result;

      if (g_simple_async_result_propagate_error (simple, error))
        return NULL;

      cake = CAKE (g_simple_async_result_get_op_res_gpointer (simple));
      return g_object_ref (cake);
    }

## Functions

### GSimpleAsyncThreadFunc ()

    void
    (*GSimpleAsyncThreadFunc) (GSimpleAsyncResult *res,
                               GObject *object,
                               GCancellable *cancellable);

Simple thread function that runs an asynchronous operation and checks for cancellation.

#### Parameters

res | a GSimpleAsyncResult. |
object | a GObject. |
cancellable | optional GCancellable object, `NULL` to ignore. |

### g_simple_async_result_new ()

    GSimpleAsyncResult *
    g_simple_async_result_new (GObject *source_object,
                               GAsyncReadyCallback callback,
                               gpointer user_data,
                               gpointer source_tag);

`g_simple_async_result_new` has been deprecated since version 2.46 and should not be used in newly-written code.

Use `g_task_new()` instead.

Creates a GSimpleAsyncResult.

The common convention is to create the GSimpleAsyncResult in the function that starts the asynchronous operation and use that same function as the `source_tag` .

If your operation supports cancellation with GCancellable (which it probably should) then you should provide the user's cancellable to `g_simple_async_result_set_check_cancellable()` immediately after this function returns.

#### Parameters

source_object | a GObject, or `NULL`. | [allow-none]
callback | a GAsyncReadyCallback. | [scope async]
user_data | user data passed to `callback` . | [closure]
source_tag | the asynchronous function. |

#### Returns

a GSimpleAsyncResult.

### g_simple_async_result_new_error ()

    GSimpleAsyncResult *
    g_simple_async_result_new_error (GObject *source_object,
                                     GAsyncReadyCallback callback,
                                     gpointer user_data,
                                     GQuark domain,
                                     gint code,
                                     const char *format,
                                     ...);

`g_simple_async_result_new_error` has been deprecated since version 2.46 and should not be used in newly-written code.

Use `g_task_new()` and `g_task_return_new_error()` instead.

Creates a new GSimpleAsyncResult with a set error.

#### Parameters

source_object | a GObject, or `NULL`. | [allow-none]
callback | a GAsyncReadyCallback. | [scope async]
user_data | user data passed to `callback` . | [closure]
domain | a GQuark. |
code | an error code. |
format | a string with format characters. |
... | a list of values to insert into `format` . |

#### Returns

a GSimpleAsyncResult.

### g_simple_async_result_new_from_error ()

    GSimpleAsyncResult *
    g_simple_async_result_new_from_error (GObject *source_object,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data,
                                          const GError *error);

`g_simple_async_result_new_from_error` has been deprecated since version 2.46 and should not be used in newly-written code.

Use `g_task_new()` and `g_task_return_error()` instead.

Creates a GSimpleAsyncResult from an error condition.

#### Parameters

source_object | a GObject, or `NULL`. | [allow-none]
callback | a GAsyncReadyCallback. | [scope async]
user_data | user data passed to `callback` . | [closure]
error | a GError |

#### Returns

a GSimpleAsyncResult.

### g_simple_async_result_new_take_error ()

    GSimpleAsyncResult *
    g_simple_async_result_new_take_error (GObject *source_object,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data,
                                          GError *error);

`g_simple_async_result_new_take_error` has been deprecated since version 2.46 and should not be used in newly-written code.

Use `g_task_new()` and `g_task_return_error()` instead.

Creates a GSimpleAsyncResult from an error condition, and takes over the caller's ownership of `error` , so the caller does not need to free it anymore.

[skip]

#### Parameters

source_object | a GObject, or `NULL`. | [allow-none]
callback | a GAsyncReadyCallback. | [scope async]
user_data | user data passed to `callback` . | [closure]
error | a GError |

#### Returns

a GSimpleAsyncResult

Since: 2.28

### g_simple_async_result_set_check_cancellable ()

    void
    g_simple_async_result_set_check_cancellable
                                   (GSimpleAsyncResult *simple,
                                    GCancellable *check_cancellable);

`g_simple_async_result_set_check_cancellable` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask instead.

Sets a GCancellable to check before dispatching results.

This function has one very specific purpose: the provided cancellable is checked at the time of `g_simple_async_result_propagate_error()` If it is cancelled, these functions will return an "Operation was cancelled" error (`G_IO_ERROR_CANCELLED`).

Implementors of cancellable asynchronous functions should use this in order to provide a guarantee to their callers that cancelling an async operation will reliably result in an error being returned for that operation (even if a positive result for the operation has already been sent as an idle to the main context to be dispatched).

The checking described above is done regardless of any call to the unrelated `g_simple_async_result_set_handle_cancellation()` function.

#### Parameters

simple | a GSimpleAsyncResult |
check_cancellable | a GCancellable to check, or `NULL` to unset. | [allow-none]

Since: 2.32

### g_simple_async_result_set_op_res_gpointer ()

    void
    g_simple_async_result_set_op_res_gpointer
                                   (GSimpleAsyncResult *simple,
                                    gpointer op_res,
                                    GDestroyNotify destroy_op_res);

`g_simple_async_result_set_op_res_gpointer` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_return_pointer()` instead.

Sets the operation result within the asynchronous result to a pointer.

[skip]

#### Parameters

simple | a GSimpleAsyncResult. |
op_res | a pointer result from an asynchronous function. |
destroy_op_res | a GDestroyNotify function. |

### g_simple_async_result_get_op_res_gpointer ()

    gpointer
    g_simple_async_result_get_op_res_gpointer
                                   (GSimpleAsyncResult *simple);

`g_simple_async_result_get_op_res_gpointer` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_propagate_pointer()` instead.

Gets a pointer result as returned by the asynchronous function.

[skip]

#### Parameters

simple | a GSimpleAsyncResult. |

#### Returns

a pointer from the result.

### g_simple_async_result_set_op_res_gssize ()

    void
    g_simple_async_result_set_op_res_gssize
                                   (GSimpleAsyncResult *simple,
                                    gssize op_res);

`g_simple_async_result_set_op_res_gssize` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_return_int()` instead.

Sets the operation result within the asynchronous result to the given `op_res` .

#### Parameters

simple | a GSimpleAsyncResult. |
op_res | a gssize. |

### g_simple_async_result_get_op_res_gssize ()

    gssize
    g_simple_async_result_get_op_res_gssize
                                   (GSimpleAsyncResult *simple);

`g_simple_async_result_get_op_res_gssize` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_propagate_int()` instead.

Gets a gssize from the asynchronous result.

#### Parameters

simple | a GSimpleAsyncResult. |

#### Returns

a gssize returned from the asynchronous function.

### g_simple_async_result_set_op_res_gboolean ()

    void
    g_simple_async_result_set_op_res_gboolean
                                   (GSimpleAsyncResult *simple,
                                    gboolean op_res);

`g_simple_async_result_set_op_res_gboolean` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_return_boolean()` instead.

Sets the operation result to a boolean within the asynchronous result.

#### Parameters

simple | a GSimpleAsyncResult. |
op_res | a gboolean. |

### g_simple_async_result_get_op_res_gboolean ()

    gboolean
    g_simple_async_result_get_op_res_gboolean
                                   (GSimpleAsyncResult *simple);

`g_simple_async_result_get_op_res_gboolean` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_propagate_boolean()` instead.

Gets the operation result boolean from within the asynchronous result.

#### Parameters

simple | a GSimpleAsyncResult. |

#### Returns

`TRUE` if the operation's result was `TRUE`, `FALSE` if the operation's result was `FALSE`.

### g_simple_async_result_get_source_tag ()

    gpointer
    g_simple_async_result_get_source_tag (GSimpleAsyncResult *simple);

`g_simple_async_result_get_source_tag` has been deprecated since version 2.46. and should not be used in newly-written code.

Use GTask and `g_task_get_source_tag()` instead.

Gets the source tag for the GSimpleAsyncResult.

[skip]

#### Parameters

simple | a GSimpleAsyncResult. |

#### Returns

a gpointer to the source object for the GSimpleAsyncResult.

### g_simple_async_result_is_valid ()

    gboolean
    g_simple_async_result_is_valid (GAsyncResult *result,
                                    GObject *source,
                                    gpointer source_tag);

`g_simple_async_result_is_valid` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_is_valid()` instead.

Ensures that the data passed to the _finish function of an async operation is consistent. Three checks are performed.

First, `result` is checked to ensure that it is really a GSimpleAsyncResult. Second, `source` is checked to ensure that it matches the source object of `result` . Third, `source_tag` is checked to ensure that it is equal to the `source_tag` argument given to `g_simple_async_result_new()` (which, by convention, is a pointer to the _async function corresponding to the _finish function from which this function is called). (Alternatively, if either `source_tag` or `result` 's source tag is `NULL`, then the source tag check is skipped.)

#### Parameters

result | the GAsyncResult passed to the _finish function. |
source | the GObject passed to the _finish function. | [allow-none]
source_tag | the asynchronous function. | [allow-none]

#### Returns

TRUE if all checks passed or FALSE if any failed.

Since: 2.20

### g_simple_async_result_set_handle_cancellation ()

    void
    g_simple_async_result_set_handle_cancellation
                                   (GSimpleAsyncResult *simple,
                                    gboolean handle_cancellation);

`g_simple_async_result_set_handle_cancellation` has been deprecated since version 2.46 and should not be used in newly-written code.

Sets whether to handle cancellation within the asynchronous operation.

This function has nothing to do with `g_simple_async_result_set_check_cancellable()`. It only refers to the GCancellable passed to `g_simple_async_result_run_in_thread()`.

#### Parameters

simple | a GSimpleAsyncResult. |
handle_cancellation | a gboolean. |

### g_simple_async_result_complete ()

    void
    g_simple_async_result_complete (GSimpleAsyncResult *simple);

`g_simple_async_result_complete` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask instead.

Completes an asynchronous I/O job immediately. Must be called in the thread where the asynchronous result was to be delivered, as it invokes the callback directly. If you are in a different thread use `g_simple_async_result_complete_in_idle()`.

Calling this function takes a reference to `simple` for as long as is needed to complete the call.

#### Parameters

simple | a GSimpleAsyncResult. |

### g_simple_async_result_complete_in_idle ()

    void
    g_simple_async_result_complete_in_idle
                                   (GSimpleAsyncResult *simple);

`g_simple_async_result_complete_in_idle` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask instead.

Completes an asynchronous function in an idle handler in the thread-default main context of the thread that `simple` was initially created in (and re-pushes that context around the invocation of the callback).

Calling this function takes a reference to `simple` for as long as is needed to complete the call.

#### Parameters

simple | a GSimpleAsyncResult. |

### g_simple_async_result_run_in_thread ()

    void
    g_simple_async_result_run_in_thread (GSimpleAsyncResult *simple,
                                         GSimpleAsyncThreadFunc func,
                                         int io_priority,
                                         GCancellable *cancellable);

`g_simple_async_result_run_in_thread` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_run_in_thread()` instead.

Runs the asynchronous job in a separate thread and then calls `g_simple_async_result_complete_in_idle()` on `simple` to return the result to the appropriate main loop.

Calling this function takes a reference to `simple` for as long as is needed to run the job and report its completion.

[skip]

#### Parameters

simple | a GSimpleAsyncResult. |
func | a GSimpleAsyncThreadFunc. |
io_priority | the io priority of the request. |
cancellable | optional GCancellable object, `NULL` to ignore. | [allow-none]

### g_simple_async_result_set_from_error ()

    void
    g_simple_async_result_set_from_error (GSimpleAsyncResult *simple,
                                          const GError *error);

`g_simple_async_result_set_from_error` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_return_error()` instead.

Sets the result from a GError.

#### Parameters

simple | a GSimpleAsyncResult. |
error | GError. |

### g_simple_async_result_take_error ()

    void
    g_simple_async_result_take_error (GSimpleAsyncResult *simple,
                                      GError *error);

`g_simple_async_result_take_error` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_return_error()` instead.

Sets the result from `error` , and takes over the caller's ownership of `error` , so the caller does not need to free it any more.

[skip]

#### Parameters

simple | a GSimpleAsyncResult |
error | a GError |

Since: 2.28

### g_simple_async_result_propagate_error ()

    gboolean
    g_simple_async_result_propagate_error (GSimpleAsyncResult *simple,
                                           GError **dest);

`g_simple_async_result_propagate_error` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask instead.

Propagates an error from within the simple asynchronous result to a given destination.

If the GCancellable given to a prior call to `g_simple_async_result_set_check_cancellable()` is cancelled then this function will return `TRUE` with `dest` set appropriately.

#### Parameters

simple | a GSimpleAsyncResult. |
dest | a location to propagate the error to. | [out]

#### Returns

`TRUE` if the error was propagated to `dest` . `FALSE` otherwise.

### g_simple_async_result_set_error ()

    void
    g_simple_async_result_set_error (GSimpleAsyncResult *simple,
                                     GQuark domain,
                                     gint code,
                                     const char *format,
                                     ...);

`g_simple_async_result_set_error` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_return_new_error()` instead.

Sets an error within the asynchronous result without a GError.

[skip]

#### Parameters

simple | a GSimpleAsyncResult. |
domain | a GQuark (usually G_IO_ERROR). |
code | an error code. |
format | a formatted error reporting string. |
... | a list of variables to fill in `format` . |

### g_simple_async_result_set_error_va ()

    void
    g_simple_async_result_set_error_va (GSimpleAsyncResult *simple,
                                        GQuark domain,
                                        gint code,
                                        const char *format,
                                        va_list args);

`g_simple_async_result_set_error_va` has been deprecated since version 2.46 and should not be used in newly-written code.

Use GTask and `g_task_return_error()` instead.

Sets an error within the asynchronous result without a GError. Unless writing a binding, see `g_simple_async_result_set_error()`.

[skip]

#### Parameters

simple | a GSimpleAsyncResult. |
domain | a GQuark (usually G_IO_ERROR). |
code | an error code. |
format | a formatted error reporting string. |
args | va_list of arguments. |

### g_simple_async_report_error_in_idle ()

    void
    g_simple_async_report_error_in_idle (GObject *object,
                                         GAsyncReadyCallback callback,
                                         gpointer user_data,
                                         GQuark domain,
                                         gint code,
                                         const char *format,
                                         ...);

`g_simple_async_report_error_in_idle` has been deprecated since version 2.46 and should not be used in newly-written code.

Use `g_task_report_error()`.

Reports an error in an asynchronous function in an idle function by directly setting the contents of the GAsyncResult with the given error information.

[skip]

#### Parameters

object | a GObject, or `NULL`. | [allow-none]
callback | a GAsyncReadyCallback. |
user_data | user data passed to `callback` . |
domain | a GQuark containing the error domain (usually G_IO_ERROR). |
code | a specific error code. |
format | a formatted error reporting string. |
... | a list of variables to fill in `format` . |

### g_simple_async_report_gerror_in_idle ()

    void
    g_simple_async_report_gerror_in_idle (GObject *object,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data,
                                          const GError *error);

`g_simple_async_report_gerror_in_idle` has been deprecated since version 2.46 and should not be used in newly-written code.

Use `g_task_report_error()`.

Reports an error in an idle function. Similar to `g_simple_async_report_error_in_idle()`, but takes a GError rather than building a new one.

#### Parameters

object | a GObject, or `NULL`. | [allow-none]
callback | a GAsyncReadyCallback. | [scope async]
user_data | user data passed to `callback` . | [closure]
error | the GError to report |

### g_simple_async_report_take_gerror_in_idle ()

    void
    g_simple_async_report_take_gerror_in_idle
                                   (GObject *object,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data,
                                    GError *error);

`g_simple_async_report_take_gerror_in_idle` has been deprecated since version 2.46 and should not be used in newly-written code.

Use `g_task_report_error()`.

Reports an error in an idle function. Similar to `g_simple_async_report_gerror_in_idle()`, but takes over the caller's ownership of `error` , so the caller does not have to free it any more.

[skip]

#### Parameters

object | a GObject, or `NULL`. | [allow-none]
callback | a GAsyncReadyCallback. |
user_data | user data passed to `callback` . |
error | the GError to report |

Since: 2.28

## Types and Values

### GSimpleAsyncResult

    typedef struct _GSimpleAsyncResult GSimpleAsyncResult;

A simple implementation of GAsyncResult.

## See Also

GAsyncResult, GTask